C. "sample_two.self"	K. J. Turner	21/11/98

H. Sample Two

Q. A <tt>make</tt> target:

  W. is one of the source files under control of <tt>make</tt>.
  
  W. is the program to be built by <tt>make</tt>.
  E. This is likely to be only one of several targets.
  
  R. is one of a list of goals that a <tt>makefile</tt> can achieve.
  E. These might include building a program, testing it and installing it.

Q. Typical <tt>makefile</tt> targets include:

  W. compile, info, system
  E. An <tt>info</tt> target is fairly common.
    
  W. configure, program, clean
  E. A <tt>clean</tt> target is normal practice.
  
  R. all, <i>program</i>, install, test, clean

Q. A <tt>makefile</tt> entry of the form:
<pre>
A: B C
	D
	E
</pre>
<p>
means:

  W. <tt>A</tt> is used to build both <tt>B</tt> and <tt>C</tt>, following
  instructions <tt>D</tt> and <tt>E</tt>.

  R. <tt>A</tt> depends on both <tt>B</tt> and <tt>C</tt>, and is built
  according to instructions <tt>D</tt> and <tt>E</tt>.

  W. <tt>A</tt> is built from <tt>D</tt> and <tt>E</tt>, according to
  instructions <tt>B</tt> and <tt>C</tt>.

Q. A short-hand in a <tt>makefile</tt> can be defined and used with a macro
notation like:

  R.
  <pre>
    SOURCES = main.c test.c analyse.c
    
    archive: $(SOURCES)
  </pre>
  E. In fact, a macro can also be referred to with <tt>${SOURCES}</tt>.

  W.
  <pre>
    SOURCES = { main.c test.c analyse.c }
    
    archive: ${SOURCES}
  </pre>
  E. Although a macro can be referred to with <tt>$(SOURCES)</tt> or
  <tt>${SOURCES}</tt>, braces are not used in its definition.

  W.
  <pre>
    #define SOURCES main.c test.c analyse.c
    
    archive: SOURCES
  </pre>
  E. This is C-like notation, not <tt>make</tt>.
